/* Copyright (C) 1991, 1996, 2000 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <errno.h>
#include <signal.h>
#include <unistd.h>


/* Suspend the process until a signal arrives.
   This always returns -1 and sets errno to EINTR.  */

extern int __sys_pause(void);

int
__libc_pause (void)
{
  static int must_emulate = 0;

  if (!must_emulate)
    {
      int errno_saved = errno;
      int retval = __sys_pause();

      if (retval >= 0 || errno != ENOSYS)
	return retval;

      __set_errno(errno_saved);
      must_emulate = 1;
    }

  return __sigpause (__sigblock (0), 0);
}
weak_alias (__libc_pause, pause)
